# This is the LDAP driver for squid-auth

# TODO: Implement 2 versions of this module - one version
#       just calls an external program every time, another
#       server as a pipe to an authenticator which is spawned
#       and left open (a-la multiple authenticator support)
#       this would help expand Squid's capabilities

sub External_authenticate_user
{
    my $config = $_[0];
    my $mod_home = $_[1];
    my $uid = $_[2];
    my $realm = $_[3];
    my $passwd = $_[4];

    # First, make sure we have the config parameters we need
    my $program = $config->{'program'};
    defined( $program ) or return error( "No external program specified in $realm\'s configuration" );

    my $args = $config->{'arguments'};
    defined( $args ) or return error( "No argument format given in $realm\'s configuration" );

    # Now, perform the substitution on the arguments string
    while ( $args =~ /%{.*}/ )
    {
        $args =~ s/%{uid}/${uid}/g;
        $args =~ s/%{realm}/${realm}/g;
        $args =~ s/%{passwd}/${passwd}/g;
    }

    # Invoke the external program
    return 1;
}

1;
